<?php
session_start();
$currUser = "";
if (isset($_SESSION["currUser"])) $currUser = $_SESSION["currUser"];
?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta name="author"              content="Howard Griffin">
<meta charset="utf-8">
<meta name="viewport"            content="width=device-width, initial-scale=1.0">
<link rel="stylesheet"           type="text/css"     href="hgg_style.css"><title>List Volunteer Opportunities &amp; People</title>
</head>

<body>
<?php
//-----------------------------------------------------------------------------
// version 1   Working at Potomac CC
// version 2   PCC specific code removed, upgraded SQL & php code, misc. enhancements
// version 3.0 April, 2016, additional enhancements, tracking of IP address, MySQL table changes
//-----------------------------------------------------------------------------
include("db_connect.php");
include("set_timezone.php");
$link = connectToMysqli();
include("data_valid_fns.php");
include("masthead.php");

//--------------------------------------------------------------------
// validate and assign arguments
// Edits are in:  data_valid_fns.php which must be included
// url syntax is ....php?start=2016-02-15
//--------------------------------------------------------------------
$start = date("Y-m-d");
if (isset($_GET["start"])) {
	if (good_datetime($_GET["start"])) $start = $_GET["start"];
	else print "Invalid start date specified in URL<br>";
	}
print "<p class=\"pcc3center\">Listing of Volunteer Opportunities &amp; Volunteers ";
print "<br>starting on: $start </p>";

print "<blockquote>";
print "<p>You may choose a different start date by including the start date in the url as follows:<br>";
print " .../listVolunteerEventsPeople.php?start=2019-03-05</p>";
print "<p>If you are not logged in, the email and any non published comments are suppressed.</p>";
print "</blockquote>";
?>

<blockquote>
<p>Copy the text below, including the header line, to Notepad or your favorite text editor<br>
Save locally as a .csv file, and double click to launch via Excel<br>
Slice and Dice to your heart's content.</p>

<p class="nomargin"><span style="font-weight:bold;">
<?php
//-----------------------------------------------------------------------------
// print headers for copying into .csv file
//-----------------------------------------------------------------------------
print "event,task,start date &amp; time,stop date & time,number volunteers";
print ",first name,last name,email,date volunteered,date unvolunteered,nonPubComments";
print "</span><br>";

//-----------------------------------------------------------------------------
// first find the events
//-----------------------------------------------------------------------------
$query1  = "select * from vol_task where startTime >= '$start' ";
$result1 = mysqli_query($link,$query1);
if (!$result1) {
	print "oops, something seems to have gone wrong with query1.<br>";
	print $query1;
	print "<br>sql error: " . mysqli_error($link) . "<br>";
	}
while ($i=mysqli_fetch_row($result1)) {
	$taskID			= $i[0];
	$event_desc		= $i[1];
	$task_desc		= $i[2];
	$startTime		= substr($i[3],0,16);
	$stopTime		= substr($i[4],0,16);
	$numVolunteers	= $i[5];
	$nonPubComments	= $i[6];
	$nonPubComments	= str_replace(",","",$nonPubComments);  // strip out commas so the .csv format works
	if ( ($currUser == "") AND ($nonPubComments !== "") ) {
		$nonPubComments = "suppressed";
		}
	$part1 = "$event_desc,$task_desc,$startTime,$stopTime,$numVolunteers";
	$part4 = ",$nonPubComments";

	//-------------------------------------------------------------------------
	// second find the people in each event
	//-------------------------------------------------------------------------
	$query2  = "SELECT * FROM `vol_people` WHERE taskID = $taskID";
	$result2 = mysqli_query($link,$query2);
	if (!$result2) {
		print "oops, something seems to have gone wrong with query2.<br>";
		print $query2;
		print "<br>sql error: " . mysqli_error($link) . "<br>";
		}
	while ($j=mysqli_fetch_row($result2)) {
		$curlerID		= $j[2];
		$date_added		= substr($j[3],0,16);
		$date_removed	= substr($j[4],0,16);
		$part3 = ",$date_added,$date_removed";

		//---------------------------------------------------------------------
		// third find the names of the people in each event
		//---------------------------------------------------------------------
		$query3  = "select fname, lname, email from curlers where curlerID = $curlerID";
		$query3  = "select * from curlers where curlerID = $curlerID";
		$result3 = mysqli_query($link,$query3);
			if (!$result3) {
			print "oops, something seems to have gone wrong with query3.<br>";
			print $query3;
			print "<br>sql error: " . mysqli_error($link) . "<br>";
			}
		$k=mysqli_fetch_row($result3); // only one row to be retrieved
		$curlid = $k[0];
		$fname	= $k[1];
		$lname	= $k[2];
		$email	= $k[3];
		$part2 = ",$fname,$lname";
		if ($currUser == "") {
			$email = "suppressed";
			}
		$part2 = $part2 . "," . $email;


		//---------------------------------------------------------------------
		// now print each constructed line
		//---------------------------------------------------------------------
		print $part1.$part2.$part3.$part4."<br>";

		}	//end of selecting people loop
	}		//end of selecting events
?>
</p><p>
--- end of report ---
</blockquote>
<p>&nbsp;</p>

</body>
</html>
