<?php
session_start();
$currUser = "";
if (isset($_SESSION["currUser"])) $currUser = $_SESSION["currUser"];
?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta name="author"              content="Howard Griffin">
<meta charset="utf-8">
<meta name="viewport"            content="width=device-width, initial-scale=1.0">
<link rel="stylesheet"           type="text/css"     href="hgg_style.css">
<title>Update Volunteer Opportunities</title>
</head>

<body>
<?php
//-----------------------------------------------------------------------------
// version 1   Working at Potomac CC
// version 2   PCC specific code removed, upgraded SQL & php code, misc. enhancements
// version 3.0 April, 2016, additional enhancements, tracking of IP address, MySQL table changes
//-----------------------------------------------------------------------------
include("db_connect.php");
include("set_timezone.php");
$link = connectToMysqli();
include("masthead.php");
include("data_valid_fns.php");
if ($currUser == '') {   // not logged in means no access
	print "<p class=pcc3>Sorry, you are not authorized (not logged in) for this function.<p>";
	print "<a href=\"login.php\">return to the login page</a>";
	print "<p><a href=\"volunteers.php\">or go back to the start page</a>";
	print "<p><a href='/'>or go back to the home page</a>";
	exit();	// go directly to jail, do not pass go, do not collect $200
	}


//-----------------------------------------------------------------------------
// General variables etc.
//-----------------------------------------------------------------------------
$zero_date      = "0000-00-00 00:00:00";
$zero_day       = "0000-00-00";
$zero_time      = "00:00";
$daysToDisplay  = 10000;  // today going forward  because of fat fingers, display ALL of them
$daysToSubtract = 5;    // days of history
$am_pm          = "";
$what_taskID	= "";
$function		= "";
$taskID			= "";
$event_desc		= "";
$task_desc		= "";
$startTime		= "";
$stopTime		= "";
$numVolunteers	= "";
$nonPubComments	= "";
$startDay		= "";
$startHour		= "";
$stopHour		= "";
$return_message	= "";
$i[0]=$i[1]=$i[2]=$i[3]=$i[4]=$i[5]=$i[6]=$i[7]=$i[8]=$i[9]=$i[10]="";

//-----------------------------------------------------------------------------
// Edits are in:  data_valid_fns.php which must be included for all passed arguments
//-----------------------------------------------------------------------------
// logic and flow control
if (isset($_POST["what_taskID"])) {
	if (good_digits($_POST["what_taskID"])) $what_taskID = $_POST["what_taskID"];
	}
if (isset($_POST["function"])) {
	if (good_text($_POST["function"])) $function = $_POST["function"];
	}

// database columns
if (isset($_POST["taskID"])) {
	if (good_digits($_POST["taskID"])) $taskID = $_POST["taskID"];
	}
if (isset($_POST["event_desc"])) {
	if (good_text($_POST["event_desc"])) {
		$event_desc = $_POST["event_desc"];
		$event_desc = str_replace(","," ",$event_desc,$countStrips);
		if ($countStrips > 0) echo "<script>alert('commas deleted because of csv reports');</script>";
		}
	}
if (isset($_POST["task_desc"])) {
	if (good_text($_POST["task_desc"])) {
		$task_desc = $_POST["task_desc"];
		$task_desc = str_replace(","," ",$task_desc,$countStrips);
		if ($countStrips > 0) echo "<script>alert('commas deleted because of csv reports');</script>";
		}
	}
if (isset($_POST["startTime"])) {
	if (good_datetime($_POST["startTime"])) $startTime = $_POST["startTime"];
	}
if (isset($_POST["stopTime"])) {
	if (good_datetime($_POST["stopTime"])) $stopTime = $_POST["stopTime"];
	}
if (isset($_POST["numVolunteers"])) {
	if (good_digits($_POST["numVolunteers"])) $numVolunteers = $_POST["numVolunteers"];
	}
if (isset($_POST["nonPubComments"])) {
	if (good_text($_POST["nonPubComments"])) {
		$nonPubComments = $_POST["nonPubComments"];
		$nonPubComments = str_replace(","," ",$nonPubComments,$countStrips);
		if ($countStrips > 0) echo "<script>alert('commas deleted because of csv reports');</script>";
		}
	}

// other passed variables, used to calculate database format date/time
if (isset($_POST["startDay"])) {
	if (good_datetime($_POST["startDay"])) $startDay = $_POST["startDay"];
	}
if (isset($_POST["startHour"])) {
	if (good_datetime($_POST["startHour"])) $startHour = $_POST["startHour"];
	}
if (isset($_POST["stopHour"])) {
	if (good_datetime($_POST["stopHour"])) $stopHour = $_POST["stopHour"];
	}

// modified in March, 2012 to add a stopDay, in case a volunteer opportunity spans midnight
// an unexpected royal pita.
$stopDay = $startDay;	// yyyy-mm-dd format, will usually be the same
if ($stopHour < $startHour) {	// in military 24 hour format, must be the next day after midnight
	$zap_yyyy	= substr($stopDay,0,4);
	$zap_mm		= substr($stopDay,5,2);
	$zap_dd		= substr($stopDay,8,2);
	$zap_dd		= $zap_dd + 1;

	if (($zap_dd == "31") AND ($zap_mm == "09") ) {	// 30 days hath September
		$zap_dd = "01";
		$zap_mm = "10";
		}
	if (($zap_dd == "31") AND ($zap_mm == "04") ) {	// April
		$zap_dd = "01";
		$zap_mm = "05";
		}
	if (($zap_dd == "31") AND ($zap_mm == "06") ) {	// June
		$zap_dd = "01";
		$zap_mm = "07";
		}
	if (($zap_dd == "31") AND ($zap_mm == "11") ) {	// and November
		$zap_dd = "01";
		$zap_mm = "12";
		}

	if ($zap_dd == 32) {								// 31 have all the rest
		$zap_dd = "01";
		$zap_mm = $zap_mm +1;
		if ($zap_mm == "13") {
			$zap_mm = "01";
			$zap_yyyy = $zap_yyyy +1;
			}
		}

	// except for that damn February, and not a leap year
	if  (($zap_mm == "02") AND ($zap_dd == "29") AND ($zap_yyyy != (floor($zap_yyyy/4))*4) ) {
		$zap_mm = "03";
		$zap_dd = "01";
		}
	// but it could be a leap year and Feb 29 is OK, so chedk for Feb 30.
	if  ( ($zap_mm == "02") AND ($zap_dd == "30") ) {
		$zap_mm = "03";
		$zap_dd = "01";
		}

	// now put the dates back together.
	$stopDay = $zap_yyyy . "-" . $zap_mm . "-" . $zap_dd;

	}	// end of if stmt for stopHour < startHour


if ($what_taskID > 0) {
//-----------------------------------------------------------------------------
// Figure out the task based on taskID
//-----------------------------------------------------------------------------
	$query1  = "SELECT * FROM vol_task WHERE taskID=$what_taskID";
	$result1 = mysqli_query($link,$query1);
	$number  = mysqli_num_rows($result1);
	if ($number>0) {
		$i =  mysqli_fetch_row($result1);
		$taskID			= $i[0];
		$event_desc		= $i[1];
		$task_desc		= $i[2];
		$startTime		= $i[3];
		$stopTime		= $i[4];
		$numVolunteers	= $i[5];
		$nonPubComments	= $i[6];
		}
	}


if ($function=='updateFunction') {
	//-----------------------------------------------------------------------------
	// update the record in the vol_task table
	//-----------------------------------------------------------------------------
	$startTime = $startDay . " " . $startHour;
	$stopTime  = $stopDay .  " " . $stopHour;
	$query  = "UPDATE vol_task ";
	$query .= "SET event_desc='$event_desc', ";
	$query .= "    task_desc='$task_desc', ";
	$query .= "    startTime='$startTime', ";
	$query .= "    stopTime='$stopTime', ";
	$query .= "    numVolunteers='$numVolunteers', ";
	$query .= "    nonPubComments='$nonPubComments' ";
	$query .= "WHERE ";
	$query .= "    taskID='$taskID'";
	$result = mysqli_query($link,$query);
		if (!$result) {
			print "oops, something seems to have gone wrong with the query updateTask.<br>";
			print $query;
			print "<br>sql error: " . mysqli_error($link) . "<br>";
			exit(0);
			}
	$what_taskID = $taskID;		// hgg knows not why this line needs to be here
								// he simply knows removing it causes problems on updates
	}


if ($function=='addFunction') {
	//-----------------------------------------------------------------------------
	// add a new record to the vol_task table
	//-----------------------------------------------------------------------------
	$startTime = $startDay . " " . $startHour;
	$stopTime  = $stopDay .  " " . $stopHour;
	$query  = "INSERT INTO vol_task ";
	$query .= "  (event_desc, task_desc, startTime, stopTime, numVolunteers, nonPubComments) " ;
	$query .= "VALUES ";
	$query .= "  ('$event_desc', '$task_desc', '$startTime', '$stopTime', '$numVolunteers', '$nonPubComments') ";
	$result = mysqli_query($link,$query);
		if (!$result) {
			print "oops, something seems to have gone wrong with the query addFunction.<br>";
			print $query;
			print "<br>sql error: " . mysqli_error($link) . "<br>";
			exit(0);
		}
	//-----------------------------------------------------------------------------
	// If it was just added, find the taskID, it should be the last one created
	//-----------------------------------------------------------------------------
	$what_taskID = mysqli_insert_id($link);
	}

print "<blockquote>";

///////////////////////////////////////////////////////////////////////////////
// create a new reservation event
///////////////////////////////////////////////////////////////////////////////
print "<p class=\"pcc3nomargin\">Create a new task for volunteers</p>";
print "<table style=\"border:1px solid grey\">";
print "  <form name=addTask action=\"$_SERVER[PHP_SELF]\" method=\"POST\">";
         $function = "addFunction";
print "  <input type='hidden' name=function value='$function'>";

print "  <tr>";
print "    <td style=\"border:1px solid grey; padding:2px\">Event Description</td>";
print "    <td style=\"border:1px solid grey; padding:2px\">Task Description</td>";
print "    <td style=\"border:1px solid grey; padding:2px\">Start Date<br>yyyy-mm-dd</td>";
print "    <td style=\"border:1px solid grey; padding:2px\">Start time<br>(military)</td>";
print "    <td style=\"border:1px solid grey; padding:2px\">Stop time<br>(military)</td>";
print "    <td style=\"border:1px solid grey; padding:2px\">#<br>Vols</td>";
print "  </tr><tr>";
print "  <td style=\"border:1px solid grey; padding:2px\"><select name=event_desc> size='30'>";
print "      <option>Testing</option>";
print "      <option>Facility Rental</option>";
print "      <option>Juniors Program</option>";
print "      <option>Middle Rockers Program</option>";
print "      <option>Learn to Curl</option>";
print "      <option>Open House</option>";
print "      </select></td>";
print "  <td style=\"border:1px solid grey; padding:2px\"><input type=text name=task_desc size='30' maxlength='30'></td>";
print "  <td style=\"border:1px solid grey; padding:2px\"><input type=text name=startDay  value='$zero_day'  size='10' maxlength='10'></td>";
print "  <td style=\"border:1px solid grey; padding:2px\"><input type=text name=startHour value='$zero_time' size='5' maxlength='5'></td>";
print "  <td style=\"border:1px solid grey; padding:2px\"><input type=text name=stopHour  value='$zero_time' size='5' maxlength='5'></td>";
print "  <td style=\"border:1px solid grey; padding:2px\"><input type=text name=numVolunteers value='0' size='2' maxlength='2'></td>";
print "  </tr><tr>";
print "    <td style=\"border:1px solid grey; padding:2px\">non-published comments</td>";
print "    <td style=\"border:1px solid grey; padding:2px\"><input type=text name=nonPubComments  size='30' maxlength='45'></td>";
print "    <td><input type='submit' value='Add Me'></td>";
print "  </tr>";
print "  </form>";
print "</table>";


///////////////////////////////////////////////////////////////////////////////
// choose an event and task to update
///////////////////////////////////////////////////////////////////////////////
print "<p class=\"pcc3nomargin\"><br>Choose a volunteer event / task if you need to modify it. (sorted by date)</p>";

print "<table><tr><td>";
print "<form name=queryEvent action=\"$_SERVER[PHP_SELF]\" method=\"POST\">";
print "<select name=\"what_taskID\" size=\"10\" onchange=\"queryEvent.submit()\"> ";
$query  = "SELECT * from vol_task   ";
$query .= "  WHERE  startTime >= DATE_SUB(CURDATE(),INTERVAL '$daysToSubtract' DAY) AND startTime <= DATE_ADD(CURDATE(),INTERVAL '$daysToDisplay' DAY)";
$query .= "  ORDER BY startTime, taskID";

$result = mysqli_query($link,$query);
if (!$result) {
	print "oops, something seems to have gone wrong with the find-an-event.<br>";
	print $query;
	print "<br>sql error: " . mysqli_error($link) . "<br>";
	}

while ($i=mysqli_fetch_row($result)) {
	$taskID_hold     = $i[0];
	$event_desc_hold = $i[1];
	$task_desc_hold  = $i[2];
	$startTime_hold  = $i[3];
	$tempDate = new DateTime($startTime_hold);
	$display_date = $tempDate->format("Y-m-d g:i a (D)");
	print "<option value='" . $taskID_hold . "'>" . $taskID_hold . " " . $display_date . " &nbsp; " . $event_desc_hold . " / ". $task_desc_hold . "</option>";
}
print "</select>";
print "</form>";
print "</td>";
print "</td><td> &nbsp; &nbsp; &nbsp; </td><td>"; // 3 columns just to separate the button
include("logoutButton.php");
print "<br>";
//print "<a href=\"volunteers.php\">Jump to volunteering page</a>";

print "<form action=\"volunteers.php\">";
print "<input type=\"submit\" value=\"Jump to volunteering page\">";
print "</form>";



print "</tr></table>";


///////////////////////////////////////////////////////////////////////////////
// Update an event, either the one you just chose, or the one you just added
///////////////////////////////////////////////////////////////////////////////
if ($what_taskID > 0) {
print "<p class=\"pcc3nomargin\"><br>Update an existing volunteer event / task</p>";

print "<table style=\"border:1px solid grey; padding:2px\">";
print "<form name=updateAnEvent action=\"$_SERVER[PHP_SELF]\" method=\"POST\">";
		$function = "updateFunction";
print "  <input type='hidden' name=function value='$function'>";
print "  <input type='hidden' name=taskID value='$what_taskID'>";
print "  <tr>";
print "    <td style=\"border:1px solid grey; padding:2px\">ID</td>";
print "    <td style=\"border:1px solid grey; padding:2px\">Event Description</td>";
print "    <td style=\"border:1px solid grey; padding:2px\">Task Description</td>";
print "    <td style=\"border:1px solid grey; padding:2px\">Start Date<br>yyyy-mm-dd</td>";
print "    <td style=\"border:1px solid grey; padding:2px\">Start time<br>(military)</td>";
print "    <td style=\"border:1px solid grey; padding:2px\">Stop time<br>(military)</td>";
print "    <td style=\"border:1px solid grey; padding:2px\">#<br>Vols</td>";
print "  </tr><tr>";
print "    <td style=\"border:1px solid grey; padding:2px\">$what_taskID</td>"; // not an input here because it should not be updated here
print "    <td style=\"border:1px solid grey; padding:2px\"><input type=text name=event_desc value='$event_desc' maxlength='30'></td>";
print "    <td style=\"border:1px solid grey; padding:2px\"><input type=text name=task_desc value='$task_desc'size='30' maxlength='30'></td>";
		$startDay=(substr($startTime,0,10));
		$startHour=(substr($startTime,11,5));
		$stopHour =(substr($stopTime,11,5));
print "  <td style=\"border:1px solid grey; padding:2px\"><input type=text name=startDay value='$startDay' size='10' maxlength='10'></td>";
print "  <td style=\"border:1px solid grey; padding:2px\"><input type=text name=startHour value='$startHour' size='5' maxlength='5'></td>";
print "  <td style=\"border:1px solid grey; padding:2px\"><input type=text name=stopHour  value='$stopHour'  size='5' maxlength='5'></td>";
print "  <td style=\"border:1px solid grey; padding:2px\"><input type=text name=numVolunteers value='$numVolunteers' size='2' maxlength='2'></td>";
print "  </tr><tr>";
print "  <td></td>";
print "    <td style=\"border:1px solid grey; padding:2px\">non-published comments</td>";
print "    <td style=\"border:1px solid grey; padding:2px\"><input type=text name=nonPubComments  value='$nonPubComments' size='30' maxlength='45'></td>";
print "    <td><input type='submit' value='Update Me'></td>";
print "  </tr>";
print "</form>";
print "</table>";

print "<p class=\"nomargin\">To cancel an activity, enter 0000-00-00 for the start date.<br>";
print "<span style=\"color: #f00;\">If you are changing a date, ";
print "  please verify that the volunteers are willling to volunteer ";
print "  at the new date/time, or that there aren't any volunteers.</span><br>";
print "  A better choice may be to cancel the event using 0000-00-00 as a date ";
print "  and add a new activity. Your volunteers will need to volunteer again.</p>";
}
?>

<br>
</blockquote>
</body>
</html>
